# Dictionary learning with cone atoms and application to anomaly detection

These programs implement the algorithms from the paper
"Dictionary learning with cone atoms and application
to anomaly detection", by Andra Băltoiu, Denis C. Ilie-Ablachim,
and Bogdan Dumitrescu, August 2023.

The programs use data that should be downloaded from
[http://asydil.upb.ro/wp-content/uploads/2023/08/dependency_30.zip](http://asydil.upb.ro/wp-content/uploads/2023/08/dependency_30.zip)
and installed in a folder '../DATA_DEPENDENCY/'
(or in any other folder that you like, but then you need to modify
the test programs). The dependency dataset was generated according to the implementation in [ADBench](https://github.com/Minqi824/ADBench).

The programs use a dictionary learning function called `DL`.
Such a function can be found in the toolbox
[https://gitlab.com/pirofti/dl-box](https://gitlab.com/pirofti/dl-box).
The `DL` function is used only for comparison with standard dictionary learning algorithms.

**Run first:**
- `draw_err_conedl.m`: generates a plot like those in Figure 8 from the paper.
  Change the variable `nf` to select another dataset.
  The first figure (musk) was already generated and it will be loaded instantly.
  For another figure, you'll have to wait a minute or so.

- `test_all_dl_ad`: gives anomaly detection results (ROC AUC) like in the paper.
  There are only two datasets, and the result is averaged on only `n_tests=2` tests,
  for only 2 combinations of parameters, in order to have a short execution time.
  The radii are uniformly distributed between `rad_min` and `rad_max`.

**Important algorithms:**
- `omp_cone_single.m`: sparse representation of a signal using Cone-OMP.
- `dl_cone_paksvd_opt.m`: Cone-DL.

Send any queries to [bogdan.dumitrescu@upb.ro](mailto:bogdan.dumitrescu@upb.ro).
